io.vertx.rxjava.core.http

## Class ServerWebSocket

- java.lang.Object
- - io.vertx.rxjava.core.http.ServerWebSocket

- All Implemented Interfaces:
    WebSocketBase, ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public class ServerWebSocket
      extends Object
      implements WebSocketBase

  Represents a server side WebSocket.

  Instances of this class are passed into a `HttpServer.websocketHandler(io.vertx.core.Handler<io.vertx.rxjava.core.http.ServerWebSocket>)` or provided when a WebSocket handshake is manually `HttpServerRequest.upgrade()`ed.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static TypeArg<ServerWebSocket>` | `__TYPE_ARG`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ServerWebSocket(ServerWebSocket delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `binaryHandlerID()` When a `Websocket` is created it automatically registers an event handler with the event bus - the ID of that handler is given by this method.
    `WebSocketBase` | `binaryMessageHandler(Handler<Buffer> handler)` Set a binary message handler on the connection.
    `void` | `close()` Close the WebSocket.
    `ServerWebSocket` | `closeHandler(Handler<Void> handler)` Set a close handler.
    `ServerWebSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Calls `WebSocketBase.close()`
    `void` | `end(Buffer t)` Same as `WebSocketBase.end(io.vertx.rxjava.core.buffer.Buffer)` but writes some data to the stream before ending.
    `ServerWebSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `ServerWebSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `ServerWebSocket` | `frameHandler(Handler<WebSocketFrame> handler)` Set a frame handler on the connection.
    `ServerWebSocket` | `getDelegate()`
    `ServerWebSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `MultiMap` | `headers()`
    `SocketAddress` | `localAddress()`
    `static ServerWebSocket` | `newInstance(ServerWebSocket arg)`
    `String` | `path()`
    `ServerWebSocket` | `pause()` Pause the `ReadSupport`.
    `String` | `query()`
    `void` | `reject()` Reject the WebSocket.
    `SocketAddress` | `remoteAddress()`
    `ServerWebSocket` | `resume()` Resume reading.
    `ServerWebSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `String` | `textHandlerID()` When a `Websocket` is created it automatically registers an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.
    `WebSocketBase` | `textMessageHandler(Handler<String> handler)` Set a text message handler on the connection.
    `rx.Observable<Buffer>` | `toObservable()`
    `String` | `uri()`
    `ServerWebSocket` | `write(Buffer data)` Write some data to the stream.
    `ServerWebSocket` | `writeBinaryMessage(Buffer data)` Writes a (potentially large) piece of binary data to the connection.
    `ServerWebSocket` | `writeFinalBinaryFrame(Buffer data)` Write a final WebSocket binary frame to the connection
    `ServerWebSocket` | `writeFinalTextFrame(String text)` Write a final WebSocket text frame to the connection
    `ServerWebSocket` | `writeFrame(WebSocketFrame frame)` Write a WebSocket frame to the connection
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
    `WebSocketBase` | `writeTextMessage(String text)` Writes a (potentially large) piece of text data to the connection.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.rxjava.core.http.WebSocketBase

      `newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.ReadStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.WriteStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.StreamBase

      `newInstance`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final TypeArg<ServerWebSocket> __TYPE_ARG

  - ### Constructor Detail

    - #### ServerWebSocket

          public ServerWebSocket(ServerWebSocket delegate)

  - ### Method Detail

    - #### getDelegate

          public ServerWebSocket getDelegate()

      Specified by:
        `getDelegate` in interface `WebSocketBase`
      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public rx.Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### end

          public void end(Buffer t)

      Same as `WebSocketBase.end(io.vertx.rxjava.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `t` -

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WebSocketBase`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        true if write queue is full

    - #### binaryHandlerID

          public String binaryHandlerID()

      When a `Websocket` is created it automatically registers an event handler with the event bus - the ID of that handler is given by this method.

      Given this ID, a different event loop can send a binary frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Specified by:
        `binaryHandlerID` in interface `WebSocketBase`
      Returns:
        the binary handler id

    - #### textHandlerID

          public String textHandlerID()

      When a `Websocket` is created it automatically registers an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.

      Given this ID, a different event loop can send a text frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Specified by:
        `textHandlerID` in interface `WebSocketBase`
      Returns:

    - #### writeTextMessage

          public WebSocketBase writeTextMessage(String text)

      Writes a (potentially large) piece of text data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Specified by:
        `writeTextMessage` in interface `WebSocketBase`
      Parameters:
        `text` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### textMessageHandler

          public WebSocketBase textMessageHandler(Handler<String> handler)

      Set a text message handler on the connection. This handler will be called similar to the , but the buffer will be converted to a String first
      Specified by:
        `textMessageHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### binaryMessageHandler

          public WebSocketBase binaryMessageHandler(Handler<Buffer> handler)

      Set a binary message handler on the connection. This handler serves a similar purpose to `handler(io.vertx.core.Handler<io.vertx.rxjava.core.buffer.Buffer>)` except that if a message comes into the socket in multiple frames, the data from the frames will be aggregated into a single buffer before calling the handler (using `WebSocketFrame.isFinal()` to find the boundaries).
      Specified by:
        `binaryMessageHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### end

          public void end()

      Calls `WebSocketBase.close()`
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### close

          public void close()

      Close the WebSocket.
      Specified by:
        `close` in interface `WebSocketBase`

    - #### remoteAddress

          public SocketAddress remoteAddress()

      Specified by:
        `remoteAddress` in interface `WebSocketBase`
      Returns:
        the remote address for this socket

    - #### localAddress

          public SocketAddress localAddress()

      Specified by:
        `localAddress` in interface `WebSocketBase`
      Returns:
        the local address for this socket

    - #### exceptionHandler

          public ServerWebSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `WebSocketBase`
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          public ServerWebSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `WebSocketBase`
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public ServerWebSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadSupport`. While it's paused, no data will be sent to the `dataHandler`
      Specified by:
        `pause` in interface `WebSocketBase`
      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public ServerWebSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading. If the `ReadSupport` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `WebSocketBase`
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public ServerWebSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `WebSocketBase`
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public ServerWebSocket write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WebSocketBase`
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public ServerWebSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, the number of `Message` for a `MessageProducer`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WebSocketBase`
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public ServerWebSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pump` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.
      Specified by:
        `drainHandler` in interface `WebSocketBase`
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFrame

          public ServerWebSocket writeFrame(WebSocketFrame frame)

      Description copied from interface: `WebSocketBase`
      Write a WebSocket frame to the connection
      Specified by:
        `writeFrame` in interface `WebSocketBase`
      Parameters:
        `frame` - the frame to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFinalTextFrame

          public ServerWebSocket writeFinalTextFrame(String text)

      Description copied from interface: `WebSocketBase`
      Write a final WebSocket text frame to the connection
      Specified by:
        `writeFinalTextFrame` in interface `WebSocketBase`
      Parameters:
        `text` - The text to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFinalBinaryFrame

          public ServerWebSocket writeFinalBinaryFrame(Buffer data)

      Description copied from interface: `WebSocketBase`
      Write a final WebSocket binary frame to the connection
      Specified by:
        `writeFinalBinaryFrame` in interface `WebSocketBase`
      Parameters:
        `data` - The data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeBinaryMessage

          public ServerWebSocket writeBinaryMessage(Buffer data)

      Description copied from interface: `WebSocketBase`
      Writes a (potentially large) piece of binary data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Specified by:
        `writeBinaryMessage` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### closeHandler

          public ServerWebSocket closeHandler(Handler<Void> handler)

      Description copied from interface: `WebSocketBase`
      Set a close handler. This will be called when the WebSocket is closed.
      Specified by:
        `closeHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### frameHandler

          public ServerWebSocket frameHandler(Handler<WebSocketFrame> handler)

      Description copied from interface: `WebSocketBase`
      Set a frame handler on the connection. This handler will be called when frames are read on the connection.
      Specified by:
        `frameHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### uri

          public String uri()

    - #### path

          public String path()

      Returns:
        the WebSocket handshake path.

    - #### query

          public String query()

      Returns:
        the WebSocket handshake query string.

    - #### headers

          public MultiMap headers()

      Returns:
        the headers in the WebSocket handshake

    - #### reject

          public void reject()

      Reject the WebSocket.

      Calling this method from the websocket handler when it is first passed to you gives you the opportunity to reject the websocket, which will cause the websocket handshake to fail by returning a 404 response code.

      You might use this method, if for example you only want to accept WebSockets with a particular path.

    - #### newInstance

          public static ServerWebSocket newInstance(ServerWebSocket arg)

Copyright © 2017. All rights reserved.